'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Searches the NPM registry via web API: https://github.com/npm/registry/blob/master/docs/REGISTRY-API.md
 */
var Searcher = /** @class */ (function () {
    function Searcher(repoUri) {
        if (repoUri === void 0) { repoUri = 'https://registry.npmjs.org/'; }
        this.repoUri = repoUri;
    }
    /**
     * Search for a jupyterlab extension.
     *
     * @param query The query to send. `keywords:"jupyterlab extension"` will be appended to the query.
     * @param page The page of results to fetch.
     * @param pageination The pagination size to use. See registry API documentation for acceptable values.
     */
    Searcher.prototype.searchExtensions = function (query, page, pageination) {
        if (page === void 0) { page = 0; }
        if (pageination === void 0) { pageination = 250; }
        var uri = new URL('/-/v1/search', this.repoUri);
        // Note: Spaces are encoded to '+' signs!
        var text = query + " keywords:\"jupyterlab extension\"";
        uri.searchParams.append('text', text);
        uri.searchParams.append('size', pageination.toString());
        uri.searchParams.append('from', (pageination * page).toString());
        return fetch(uri.toString()).then(function (response) {
            if (response.ok) {
                return response.json();
            }
            return [];
        });
    };
    return Searcher;
}());
exports.Searcher = Searcher;
//# sourceMappingURL=query.js.map